/*
    Backbone Ribs 1.0.0
    -------------------
    Base classes and app level elements to enhance Backbone.JS.

    Author: Keith Jackson
    Company: The Ministry of Technology
    Date: October 2014
    Last Updated: October 2014
 
    Initialisation code taken from Backbone itself and adapted. 
*/
(function(t,e){if("function"==typeof define&&define.amd)define(["backbone","exports"],function(i,n){t.Ribs=e(t,n,i)});else if("undefined"!=typeof exports){var i=require("backbone");e(t,exports,i)}else t.Ribs=e(t,{},t.Backbone)})(this,function(t,e,i){Object.hasValue=function(t){return void 0!==t&&null!==t&&""!==t},Object.exists=function(t){return void 0!==t&&null!==t},Object.isTruthy=function(t){return void 0!==t&&null!==t&&1==t},Object.isFunction=function(t){if(!Object.exists(t))return!1;var e={};return t&&"[object Function]"===e.toString.call(t)},String.prototype.trim||(String.prototype.trim=function(){return this.replace(/^\s+|\s+$/g,"")},String.prototype.ltrim=function(){return this.replace(/^\s+/,"")},String.prototype.rtrim=function(){return this.replace(/\s+$/,"")},String.prototype.fulltrim=function(){return this.replace(/(?:(?:^|\n)\s+|\s+(?:$|\n))/g,"").replace(/\s+/g," ")}),String.prototype.escapeRegExp||(String.prototype.escapeRegExp=function(){return this.replace(/([.*+?^=!:${}()|\[\]\/\\])/g,"\\$1")}),String.prototype.replaceAll||(String.prototype.replaceAll=function(t,e){return this.replace(RegExp(t.escapeRegExp(),"g"),e)});var n={isNullAttribute:function(t,e){return void 0===t||null===t||void 0===t[e]||null===t[e]},isNullOrEmptyAttribute:function(t,e){return this.isNullAttribute(t,e)||""===t[e]},isNullOrFalseAttribute:function(t,e){return this.isNullAttribute(t,e)||t[e]===!1||0===t[e]||-1===t[e]||"false"===(""+t[e]).toLowerCase()}},r=function(){var t=function(e,i){return _.each(e,function(n,r){void 0!==n&&null!==n&&_.isObject(n)&&(e[r]=i>0?t(n,i-1):n),void 0!==n&&null!==n&&_.isFunction(n.toJSON)&&(e[r]=i>0?t(n.toJSON(),i-1):n.toJSON())}),e};this.toJSONRecursive=function(e){e=e||1;var i=_.clone(this.attributes);return i=t(i,e)}};return e.Model=i.Model.extend(_.extend({name:"Unnamed Model",initialize:function(t,e){this.options=e||{},i.Model.prototype.initialize.call(this,t,e),this.options.name&&(this.name=this.options.name),this.on("invalid",function(t,e){throw Error(e)})},fetch:function(t){return this.trigger("fetching",this,t),i.Model.prototype.fetch.call(this,t)}},n,new r)),e.Collection=i.Collection.extend(_.extend({name:"Unnamed Collection",initialize:function(t,e){this.options=e||{},i.Collection.prototype.initialize.call(this,t,e),this.options.name&&(this.name=this.options.name)},fetch:function(t){return this.trigger("fetching",this,t),i.Collection.prototype.fetch.call(this,t)}},n,new r)),e.View=i.View.extend({name:"Unnamed View",sectionName:"No section specified",stateRequired:!1,template:void 0,bindings:[],initialize:function(t){this.options=t||{},i.View.prototype.initialize.call(this,t),this.options.name&&(this.name=this.options.name),this.options.sectionName&&(this.sectionName=this.options.sectionName),this.options.template&&(this.template=this.options.template)},bindToModel:function(t,e,i,n){if(void 0===n||null===n)throw"The value of 'that' needs the context of the extending class in order to operate correctly.";t.bind(e,i,n),this.bindings.push({model:t,ev:e,callback:i})},dispose:function(){this.unbindFromAllModels(),this.stopListening(),this.unbind(),this.remove(),this.undelegateEvents()},render:function(){return this.trigger("rendered"),this},resetStyleState:function(){},trash:function(){this.dispose()},unbindFromAllModels:function(){_.each(this.bindings,function(t){t.model.unbind(t.ev,t.callback)}),this.bindings=[]}}),e.SimpleView=e.View.extend({template:function(){return"<b>No template defined!</b>"},initialize:function(t){this.options=t||{},e.View.prototype.initialize.call(this,t),this.options.template&&(this.template=this.options.template)},render:function(){return this.$el.html(this.template(this)),this.trigger("rendered"),this}}),e.SecureView=e.View.extend({name:"Unnamed Secure View",stateRequired:!0,securityBypass:!1,initialize:function(t){this.options=t||{},e.View.prototype.initialize.call(this,t),void 0!==this.options.securityBypass&&null!==this.options.securityBypass&&(this.securityBypass=this.options.securityBypass)},applySecureLoginPrompt:function(){if(!this.securityBypass)throw Error("A login prompt was requested but has not been implemented in the child class - this function must be replaced!")},applyTimedOutSecureLoginPrompt:function(){if(!this.securityBypass)throw Error("A login prompt was requested but has not been implemented in the child class - this function must be replaced!")},getLoggedInUserData:function(){throw Error("The 'getLoggedInUserData' function must be replaced in the child class in order to operate correctly.")},isSecured:function(){if(this.securityBypass)return!0;var t=this.getLoggedInUserData();return void 0!==t&&null!==t},render:function(){return this.secureRender()},secureRender:function(){return this.isSecured()?this.$el.html(this.template(this)):this.applySecureLoginPrompt(),this.trigger("rendered"),this}}),e.Region=e.View.extend({name:"Unnamed Region",currentView:void 0,spinner:"<p>Loading...</p>",initialize:function(t){this.options=t||{},e.View.prototype.initialize.call(this,t),this.options.currentView&&(this.currentView=this.options.currentView),_.bindAll(this,"placeRenderedView"),_.bindAll(this,"showRendering")},placeRenderedView:function(){void 0!==this.currentView&&(this.$el.html(this.currentView.$el),this.currentView.delegateEvents(),void 0!==this.currentView.postRender&&null!==this.currentView.postRender&&this.currentView.postRender())},renderView:function(t){t&&(this.currentView&&this.currentView.trash(),this.currentView=t),this.currentView.bind("rendering",this.showRendering),this.currentView.bind("rendered",this.placeRenderedView),this.currentView.render()},showRendering:function(){this.$el.html(this.spinner)},trash:function(t){this.currentView.trash(),void 0!==t&&null!==t&&t!==!1&&this.dispose()}}),e.VERSION="1.0.0",e});